<template>
  <div class="relative">
    <Field
        :label="label"
        component="input"
        type="text"
        :placeholder="placeholder"
        :name="name"
        @input="onCityChange($event.target.value)"
    />
    <ul
        class="absolute z-50 bg-white rounded shadow-xl w-full"
        :class="
              foundCities.length
                ? 'border border-yellow-600'
                : 'hidden'
            "
    >
      <li
          class="block px-4 py-2 hover:bg-yellow-600 hover:text-white"
          @click="() => { foundCities = []; onSelectCity(city) }"
          :key="city.code"
          v-for="city in foundCities"
      >
        {{ city.nom }} ({{ city.code }})
        <hr/>
      </li>
    </ul>
  </div>
</template>

<script>

import {city as cityAction} from "@/actions/RoadtripAction";

export default {
  name: "CityChoose",
  inject: ["roadtrip", "values"],
  data: () => ({
    foundCities: []
  }),
  props: {
    name: String,
    label: String,
    placeholder: String,
    reset: {
      type: Function,
      default: null
    },
    onSelectCity: Function
  },
  methods: {
    onCityChange(value) {
      if (this.reset) {
        this.reset();
      }
      if (value.length < 2) {
        this.foundCities = [];
        return;
      }
      cityAction(value).then(async res => {
        if (res.status === 404 || this.values[this.name].length < 2) {
          return;
        }
        const cities = await res.json();
        this.foundCities = cities;
      });
    }
  }
}
</script>

<style scoped>

</style>